<script setup>
import { computed, ref, nextTick } from "vue";
import { useStore } from "vuex";
import FoldOut from "@components/Template/FoldOut.vue";

// Connect to Store and Router
const store = useStore();

// Compute necessary Store values for Component
const level = computed(() => store.state.level.selected);
const config = computed(() => store.state.level.data.config || { arguments: {} });
const attrArr = computed(() => Object.entries(config.value).filter(([k]) => k != "arguments"));
const argsArr = computed(() =>
  Object.entries(config.value.arguments).map(([k, v]) => {
    return [k, v["type"]||v["collection"], v["value"]||v["query"]];
  }),
);

// Create local References
const unlocked = ref(undefined);
const unsaved = ref(false);
const nameInput = ref(null);
const inLevelNameEditMode = ref(false);
const newLevelName = ref(level.value);

function unlockLevelNameInput() {
  inLevelNameEditMode.value = true;
  nextTick(() => focusLevelNameInput());
}

function updateLevelName() {
  store
    .dispatch("level/editName", newLevelName.value)
    .then(() => (inLevelNameEditMode.value = false))
    .catch(focusLevelNameInput());
}

function resetLevelName() {
  newLevelName.value = level.value;
}

function focusLevelNameInput() {
  nameInput.value.focus; // set focus to the textbox/textarea
  nameInput.value.setActive; // make the textbox/textarea the one that is going to receive mouse and keyboard input
  nameInput.value.select(); // some browsers require this line of code for it to work right
}

function deleteProperty(key) {
  let query = { [`config.${key}`]: "" };
  store.dispatch("level/edit", { operator: "_remove", query });
  unsaved.value = false;
}

function updateConfig() {
  let obj = attrArr.value.reduce((acc, [k, v]) => ((acc[k] = v), acc), {});
  obj["arguments"] = argsArr.value.reduce((acc, [k, c, q]) => ((acc[k] = { type: c, value: q }), acc), {});
  store.dispatch("level/edit", { operator: "_set", query: { config: obj } });
  unlocked.value = undefined;
  unsaved.value = false;
}
</script>

<template>
  <div v-if="level" class="has-background-purple-5 p-5 is-scroll-container">
    <p class="title is-4 is-uppercase">level Config</p>
    <p class="title is-4 is-uppercase">Name</p>
    <div class="table-container">
      <table class="table has-background-transparent is-bordered">
        <thead>
          <tr>
            <td class="has-background-white p-0" style="width: 20ch">
              <div class="control">
                <input
                  ref="nameInput"
                  v-model="newLevelName"
                  class="input has-overflow-ellipsis is-cursor-default has-text-black"
                  type="text"
                  :disabled="!inLevelNameEditMode"
                  @keyup.enter="updateLevelName"
                />
              </div>
            </td>
            <div v-if="inLevelNameEditMode">
              <Icon :icon="'check-square'" class="m-3" @click.stop="updateLevelName" />
              <Icon v-if="newLevelName !== level" :icon="'rotate-ccw'" class="my-3" @click.stop="resetLevelName" />
            </div>
            <div v-else>
              <Icon :icon="'edit'" class="m-3" @click.stop="unlockLevelNameInput" />
            </div>
          </tr>
        </thead>
      </table>
    </div>
    <br />
    <p class="title is-4 is-uppercase">
      Attributes
      <a
        href="https://docs.adaptorex.org/basics/variables.html#level-attributes"
        target="_blank"
        rel="noopener noreferrer"
      >
        <Icon
          class="has-text-dark"
          :icon="'help-circle'"
          :tooltip="'Attributes can be used as simple variables in the level, or are displayed at certain places (e.g. the Status of the level in the Level Overview).'"
          :interactive="true"
        />
      </a>
    </p>
    <div class="table-container">
      <table class="table has-background-transparent is-bordered">
        <thead>
          <tr>
            <th class="has-background-white" style="width: 20ch">NAME</th>
            <th class="has-background-white" style="width: 60ch">VALUE</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(attribute, index) in attrArr" :key="`attr_${index}`">
            <td class="has-background-white p-0">
              <div class="control">
                <input
                  v-model="attribute[0]"
                  class="input has-overflow-ellipsis is-cursor-default has-text-black"
                  type="text"
                  :disabled="unlocked != `attr_${index}`"
                />
              </div>
            </td>
            <td class="has-background-white p-0">
              <div class="control">
                <input
                  v-model="attribute[1]"
                  class="input has-overflow-ellipsis is-cursor-default has-text-black"
                  type="text"
                  :disabled="unlocked != `attr_${index}`"
                />
              </div>
            </td>
            <div>
              <Icon
                v-if="unlocked == `attr_${index}`"
                :icon="'check-square'"
                class="m-3"
                @click.stop="updateConfig()"
              />
              <Icon v-else :icon="'edit'" class="m-3" @click.stop="unlocked = `attr_${index}`" />
              <Icon :icon="'trash-2'" @click.stop="deleteProperty(attribute[0])" />
            </div>
          </tr>
        </tbody>
      </table>
    </div>
    <div>
      <button
        class="button is-link"
        :disabled="unsaved"
        @click="
          attrArr.push([`attribute${attrArr.length - 1}`, '-']);
          unlocked = `attr_${attrArr.length - 1}`;
          unsaved = true;
        "
      >
        ADD NEW
      </button>
    </div>
    <p
      class="title is-4 is-uppercase mt-6"
      title="Define arguments that can be passed at the start of the level and/or that are available with default values as variables in the level."
    >
      Arguments
      <a
        href="https://docs.adaptorex.org/basics/variables.html#item-container-and-level-arguments"
        target="_blank"
        rel="noopener noreferrer"
      >
        <Icon
          class="has-text-dark"
          :icon="'help-circle'"
          :tooltip="'Arguments are values or items that are forwarded to the new session at the start of the level.\n\nNAME:\nVariable name to use argument in the level. \n\nTYPE (optional): \nData Type (string, number, array, object) or name of the collection the value is from. \n\nDEFAULT VALUE (optional):\nA value the argument has if it was not specified on session start. Can be an item name or query if TYPE is an items collection.'"
          :interactive="true"
        />
      </a>
    </p>
    <p class="subtitle is-6"></p>
    <br />
    <div class="table-container">
      <table class="table has-background-transparent is-bordered">
        <thead>
          <tr>
            <th class="has-background-white" style="width: 20ch">NAME</th>
            <th class="has-background-white" style="width: 20ch">TYPE</th>
            <th class="has-background-white" style="width: 40ch">DEFAULT VALUE</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(argument, index) in argsArr" :key="`args_${index}`">
            <td class="has-background-white p-0">
              <div class="control">
                <input
                  v-model="argument[0]"
                  class="input has-overflow-ellipsis is-cursor-default has-text-black"
                  type="text"
                  :disabled="unlocked != `args_${index}`"
                />
              </div>
            </td>
            <td class="has-background-white p-0">
              <div class="control">
                <input
                  v-model="argument[1]"
                  class="input has-overflow-ellipsis is-cursor-default has-text-black"
                  type="text"
                  :disabled="unlocked != `args_${index}`"
                />
              </div>
            </td>
            <td class="has-background-white p-0">
              <div class="control">
                <input
                  v-model="argument[2]"
                  class="input has-overflow-ellipsis is-cursor-default has-text-black"
                  type="text"
                  :disabled="unlocked != `args_${index}`"
                />
              </div>
            </td>
            <div>
              <Icon
                v-if="unlocked == `args_${index}`"
                :icon="'check-square'"
                class="m-3"
                @click.stop="updateConfig()"
              />
              <Icon v-else :icon="'edit'" class="m-3" @click.stop="unlocked = `args_${index}`" />
              <Icon :icon="'trash-2'" @click.stop="deleteProperty(`arguments.${argument[0]}`)" />
            </div>
          </tr>
        </tbody>
      </table>
    </div>
    <div>
      <button
        class="button is-link"
        :disabled="unsaved"
        @click="
          argsArr.push([`argument${argsArr.length - 1}`, ,]);
          unlocked = `args_${argsArr.length - 1}`;
          unsaved = true;
        "
      >
        ADD NEW
      </button>
    </div>
    <hr />
    <FoldOut>
      <template #header>
        <div class="is-flex is-flex-direction-row is-align-items-center">
          <div>Raw Config</div>
          <Icon :icon="'chevron-right'" class="m-4" />
        </div>
      </template>
      <template #default>
        <pre class="is-size-7">{{ JSON.stringify(config, null, 4) }}</pre>
      </template>
    </FoldOut>
  </div>
</template>
